/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   GSLMatrix.h
 * Author: skidmarks
 *
 * Created on December 15, 2017, 2:54 PM
 */

#ifndef GSLMATRIX_H
#define GSLMATRIX_H

# include <gsl/gsl_matrix.h>

# include "GLSData.h"
# include "GSLVector.h"

using namespace std;

namespace gls {
   
class GSLMatrix : GLSData{
public:
   GSLMatrix(size_t row, size_t col);
   GSLMatrix(size_t row, size_t col, int calloc);
   GSLMatrix(_gsl_matrix_view matrix);
   GSLMatrix(_gsl_matrix_const_view matrix);
   GSLMatrix(const GSLMatrix& orig);
   virtual ~GSLMatrix();
   virtual string toString();
  

   
   virtual int fscanf(FILE * stream, gsl_matrix * m);
   
   
   
   

   
      
   GSLMatrix   submatrix(size_t row, size_t col, size_t rows, size_t cols);
   GSLMatrix   view_vector(gsl_vector * v, size_t rows, size_t cols);
   GSLMatrix   view_vector_with_tda(gsl_vector * v, size_t rows, size_t cols, size_t tda);
   
   GSLVector   row(size_t row)                               { return GSLVector(gsl_matrix_row((gsl_matrix*)strct(), row));} ;
   GSLVector   column(size_t col)                            { return GSLVector(gsl_matrix_column((gsl_matrix*)strct(), col)); };
   GSLVector   subrow(size_t i, size_t offset, size_t n);
   GSLVector   subcolumn(size_t j, size_t offset, size_t n);
   GSLVector   diagonal()                                    { return GSLVector(gsl_matrix_diagonal((gsl_matrix*)strct()));};
   GSLVector   subdiagonal(size_t k)                         { return GSLVector(gsl_matrix_subdiagonal((gsl_matrix*)strct(), k));};
   GSLVector   superdiagonal(size_t k)                       { return GSLVector(gsl_matrix_superdiagonal((gsl_matrix*)strct(), k));};
   
   const GSLMatrix   const_submatrix(size_t k1, size_t k2,size_t n1, size_t n2);
   const GSLMatrix   const_view_vector(gsl_vector * v, size_t n1, size_t n2);
   const GSLMatrix   const_view_vector_with_tda(gsl_vector * v, size_t n1, size_t n2, size_t tda);
  
   const GSLVector   const_row(size_t row)                  { return GSLVector(gsl_matrix_const_row((gsl_matrix*)strct(), row));} ;
   const GSLVector   const_column(size_t col)               { return GSLVector(gsl_matrix_const_column((gsl_matrix*)strct(), col)); };
   
   const GSLVector   const_subrow(size_t i, size_t offset, size_t n);
   const GSLVector   const_subcolumn(size_t j, size_t offset, size_t n);
   const GSLVector   const_diagonal()                       { return GSLVector(gsl_matrix_const_diagonal((gsl_matrix*)strct()));};
   const GSLVector   const_subdiagonal(size_t k)            { return GSLVector(gsl_matrix_const_subdiagonal((gsl_matrix*)strct(), k));};
   const GSLVector   const_superdiagonal(size_t k)          { return GSLVector(gsl_matrix_const_superdiagonal((gsl_matrix*)strct(), k));};

private:
//   GSLMatrix(const GSLMatrix& orig);

};

} // namespace gls
#endif /* GSLMATRIX_H */

