/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   GSLVector.cpp
 * Author: skidmarks
 * 
 * Created on December 15, 2017, 2:54 PM
 */

# include <gsl/gsl_vector.h>
# include <gsl/gsl_vector_complex_double.h>

# include "GSLVector.h"

using namespace std;
using namespace gls;

GSLVector:: GSLVector(size_t size) : GLSData(size, gslVector, (gsl_vector_alloc(size))) { };
GSLVector::GSLVector(size_t size, int calloc) : GLSData(size, gslVector, gsl_vector_calloc(size)) { };
GSLVector::GSLVector(_gsl_vector_view vector) : GLSData( vector.vector.size
                                                       , gslVectorView
                                                       , &vector.vector) { };
GSLVector::GSLVector(_gsl_vector_const_view vector) : GLSData( vector.vector.size
                                                             , gslVectorView
                                                             , &vector.vector) { };

GSLVector::GSLVector(const GSLVector& orig) : GLSData(orig.size(), orig.id(), orig.strct()) { };

GSLVector::~GSLVector() { if (id() == gslVector) gsl_vector_free((gsl_vector*)strct()); }

/**********************************************************
 *********************************************************/
 
// int= GSL_EFAILED
 
// gcc -DHAVE_INLINE
// GSL_RANGE_CHECK_OFF
// GSL_COO_INTLINE
// gsl_check_range

GSLVector GSLVector::subvector(size_t offset, size_t n) {
   return GSLVector(gsl_vector_subvector((gsl_vector *)strct(), offset, n));
}; // GSLVector GSLVector::subvector( size_t offset, size_t n)

const GSLVector GSLVector::const_subvector(size_t offset, size_t n) {
   return GSLVector(gsl_vector_const_subvector((gsl_vector *)strct(), offset, n));
}; // const GSLVector GSLVector::const_subvector(size_t offset, size_t n)


GSLVector GSLVector::subvector_with_stride(size_t offset, size_t stride, size_t n) {
   return GSLVector(gsl_vector_subvector_with_stride((gsl_vector *)strct(), offset, stride, n));   
}; //GSLVector  GSLVector::subvector_with_stride(size_t offset, size_t sgride, size_t n)

const GSLVector GSLVector::const_subvector_with_stride(size_t offset, size_t stride, size_t n) {
   return GSLVector(gsl_vector_const_subvector_with_stride((gsl_vector *)strct(), offset, stride, n));  
}; // GSLVector GSLVector::const_subvector_with_stride(size_t offset, size_t stride, size_t n)

GSLVector GSLVector::view_array(double * base, size_t size) {
   return GSLVector(gsl_vector_view_array(base, size));
}; // GSLVector::view_array(double * base, size_t n)

const GSLVector GSLVector::const_view_array(const double * base, size_t size) {
   return GSLVector(gsl_vector_const_view_array(base, size));
}; // GSLVector::const_view_array(const double * base, size_t n) 

GSLVector GSLVector::view_array_with_stride(double * base, size_t stride, size_t size) {
   return GSLVector(gsl_vector_view_array_with_stride(base, stride, size));
}; // GSLVector::view_array_with_stride(double * base, size_t stride, size_t size)

const GSLVector GSLVector::const_view_array_with_stride(const double * base, size_t stride, size_t size) {
   return GSLVector(gsl_vector_const_view_array_with_stride(base, stride, size));
}; // GSLVector GSLVector::const_view_array_with_stride(const double * base,size_t stride, size_t n)
