/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   GSLVector.h
 * Author: skidmarks
 *
 * Created on December 15, 2017, 2:54 PM
 */

#ifndef GSLVECTOR_H
#define GSLVECTOR_H

# include <gsl/gsl_vector.h>
# include <string>

# include "GLSData.h"

using namespace std;
namespace gls {
   
class GSLVector  : GLSData {
public:
   GSLVector(size_t size);
   GSLVector(size_t size, int calloc);
   GSLVector(_gsl_vector_view vector);
   GSLVector(_gsl_vector_const_view vector);
      GSLVector(const GSLVector& orig);

   virtual ~GSLVector();
   virtual string toString();
   
   virtual void*    data()                     { return ((gsl_vector*)strct())->data;}
   virtual double   max()                      { return gsl_vector_max((gsl_vector*)strct());};
   virtual double   min()                      { return gsl_vector_min((gsl_vector*)strct());};
   
   virtual int      isnull()                   { return gsl_vector_isnull((gsl_vector*)strct());};
   virtual int      isneg()                    { return gsl_vector_isneg((gsl_vector*)strct());};
   virtual int      isnonneg()                 { return gsl_vector_isnonneg((gsl_vector*)strct());};
   virtual int      ispos()                    { return gsl_vector_ispos((gsl_vector*)strct());};
   virtual void     set_zero()                 { gsl_vector_set_zero((gsl_vector*)strct());};
   virtual void     set_all(double x)          { gsl_vector_set_all((gsl_vector*)strct(), x);};
   
   virtual double*  ptr( size_t row, size_t col = 0)           { return gsl_vector_ptr((gsl_vector*)strct(), row);};
   virtual void     set(const double x, const size_t row, const size_t col = 0)
                                               { return gsl_vector_set((gsl_vector*)strct(), row, x);};
   
   virtual const double* const_ptr(size_t ndx, size_t col = 0) { return gsl_vector_const_ptr((gsl_vector*)strct(), ndx);};
   virtual double get( const size_t ndx, size_t col = 0)       { return gsl_vector_get((gsl_vector*)strct(), ndx);};
  
   virtual int add(GLSData& b)                 { return gsl_vector_add((gsl_vector*)strct(), (gsl_vector*)b.strct());};
   virtual int add_constant(const double x)    { return gsl_vector_add_constant((gsl_vector*)strct(),x);};
   virtual int sub(GLSData& b)                 { return gsl_vector_sub((gsl_vector*)strct(), (gsl_vector*)b.strct());};

   virtual int memcpy(GLSData& dest)           { return gsl_vector_memcpy((gsl_vector*)dest.strct(), (gsl_vector*)strct()); };

   int      set_basis(size_t ndx)              { return gsl_vector_set_basis((gsl_vector*)strct(), ndx);};

   int      fscanf(FILE stream, void* ptr);

   int      memcpy(gsl_vector * dest)          { return gsl_vector_memcpy(dest, ((gsl_vector*)strct())); };
   int      swap(gsl_vector * w)               { return gsl_vector_swap((gsl_vector*)strct(), w);};
   
   int      memcpy(GSLVector& dest)            { return gsl_vector_memcpy((gsl_vector*)dest.strct(), (gsl_vector*)strct()); };
   int      swap(GSLVector& w)                 { return gsl_vector_swap((gsl_vector*)strct(), (gsl_vector*)w.strct());};

   int      swap_elements(size_t i, size_t j)  { return gsl_vector_swap_elements((gsl_vector*)strct(), i, j);};
   int      reverse()                          { return gsl_vector_reverse((gsl_vector*)strct());};

   int      add(gsl_vector * b)                { return gsl_vector_add((gsl_vector*)strct(), b);};
   int      sub(gsl_vector * b)                { return gsl_vector_sub((gsl_vector*)strct(), b);};
   int      mul(gsl_vector * b)                { return gsl_vector_mul((gsl_vector*)strct(), b);};
   int      div(gsl_vector * b)                { return gsl_vector_div((gsl_vector*)strct(), b);};

//   int      add(GSLVector& b)            { return gsl_vector_add((gsl_vector*)strct(), (gsl_vector*)b.strct());};
//   int      sub(GSLVector& b)            { return gsl_vector_sub((gsl_vector*)strct(), (gsl_vector*)b.strct());};
   int      mul(GSLVector& b)            { return gsl_vector_mul((gsl_vector*)strct(), (gsl_vector*)b.strct());};
   int      div(GSLVector& b)            { return gsl_vector_div((gsl_vector*)strct(), (gsl_vector*)b.strct());};

   int      scale(double x)                    { return gsl_vector_scale((gsl_vector*)strct(),x);};
//   int      add_constant(double x)             { return gsl_vector_add_constant((gsl_vector*)strct(),x);};

   void     minmax(double * min, double * max) { return gsl_vector_minmax((gsl_vector*)strct(), min, max);};
   size_t   max_index()                        { return gsl_vector_max_index((gsl_vector*)strct());};
   size_t   min_index()                        { return gsl_vector_min_index((gsl_vector*)strct());};
   void     minmax_index(size_t * min, size_t * max) { return gsl_vector_minmax_index((gsl_vector*)strct(), min, max);};

   GSLVector       subvector(size_t offset, size_t n);
   GSLVector       subvector_with_stride(size_t offset, size_t stride, size_t n);

   GSLVector       view_array(double * base, size_t size);
   GSLVector       view_array_with_stride(double * base, size_t stride, size_t size);
   
   const GSLVector const_subvector_with_stride(size_t offset, size_t stride, size_t n);
   const GSLVector const_subvector(size_t offset, size_t n);
   
   const GSLVector const_view_array(const double * base, size_t size);
   const GSLVector const_view_array_with_stride(const double * base, size_t stride, size_t size);

private:

};
} // namespace gls
#endif /* GSLVECTOR_H */

